

`timescale 1ns / 10ps

module tb();
	
  reg wclk,rclk,winc,rinc,wrst_n,rrst_n;
  reg  [7:0] wdata;	
  wire [7:0] rdata;
  wire wfull,rempty;  
  

 

  always #50  wclk = ~wclk;
  always #200 rclk = ~rclk;	 
	  

	initial 
	  begin
		wclk      = 1'b0;
		rclk      = 1'b0;
		winc      = 1'b0;
		rinc      = 1'b0;
		wrst_n    = 1'b0; 
		rrst_n    = 1'b0;	
		wdata     = 8'd0;	
		#100;  
		wrst_n    = 1'b1; 
		rrst_n    = 1'b1;	
	  end
	  
	  
	initial 
	  begin
		repeat (20) 
			begin
			wait(~wfull)
			winc  = 1'b1;
			wdata  = $random;
			#100;
			winc  = 1'b0; 
			#100;
	    	end	 
			#1000;
			//$finish;
			
	  end	
	  
	  initial 
	  begin
		repeat (20) 
			begin
			wait(~rempty); 
			rinc  = 1'b1;
			#400;
			rinc  = 1'b0; 
			#400;
	    	end	 
			#1000;
		end
	  
	  
 fifo1 #(8, 4) inst
(
.rdata(rdata),
.wfull(wfull),
.rempty(rempty),
.wdata(wdata),
.winc(winc), 
.wclk(wclk), 
.wrst_n(wrst_n),
.rinc(rinc), 
.rclk(rclk), 
.rrst_n(rrst_n));
  							
endmodule		 